class Value<T> {
	private T value;

	public Value(T value) {
		setValue(value);
	}

	public void setValue(T value) {
		this.value = value;
	}
	public T getValue() {
		return value;
	}
}

class A {
	public String getText() {
		return "This is A class";
	}
}
class B extends A {
	public String getText() {
		return "This is B class";
	}
}

class Test {
	static void printValue(Value<? extends A> obj) {
		System.out.println(obj.getValue().getText());
	}

	public static void main(String[] args) {
		A objA = new A();
		B objB = new B();

		Value<A> v1 = new Value<A>(objA);
		Value<B> v2 = new Value<B>(objB);
		Value<String> v3 = new Value<String>("Kitty on your lap");

		printValue(v1);
		printValue(v2);
		//printValue(v3); //G[
	}
}