import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class MoleAttack extends JFrame implements ActionListener, MouseListener {
	public static void main(String[] args) {
		JFrame frame = new MoleAttack("y@");
		frame.setBounds(0 , 0 , 640 , 480);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	private final int MOLE_COUNT = 6;

	private Random rand;
	private javax.swing.Timer timer;
	private Mole[] moles = new Mole[MOLE_COUNT];
	private MoleTimer[] moleTimers = new MoleTimer[MOLE_COUNT];
	public MoleAttack(String title) {
		super(title);
		getContentPane().setLayout(new FlowLayout());

		Image noneImage = getToolkit().createImage("none.jpg");
		Image moleImage = getToolkit().createImage("mole.jpg");
		Image attackImage = getToolkit().createImage("attack.jpg");
		Dimension size = new Dimension(200, 170);
		for(int i = 0 ; i < MOLE_COUNT ; i++) {
			moles[i] = new Mole();
			moles[i].addMouseListener(this);
			moles[i].setNoneImage(noneImage);
			moles[i].setMoleImage(moleImage);
			moles[i].setAttackImage(attackImage);
			moles[i].setPreferredSize(size);
			moles[i].setBorder(new LineBorder(new Color(0,0,0)));
			getContentPane().add(moles[i]);
		}

		rand = new Random(System.currentTimeMillis());
		timer = new javax.swing.Timer(300, this);
		timer.start();
	}

	public void actionPerformed(ActionEvent e) {
		if (rand.nextInt(2) == 0) return;
		int index = rand.nextInt(MOLE_COUNT);
		if(moles[index].getState() == Mole.STATE_NONE) {
			moles[index].setState(Mole.STATE_MOLE);
			if (moleTimers[index] != null) moleTimers[index].stop();
			moleTimers[index] = new MoleTimer(moles[index], Mole.STATE_NONE, 5000);
		}
	}
	public void mouseClicked(MouseEvent e) {
		Mole mole = (Mole)e.getSource();
		if (mole.getState() == Mole.STATE_MOLE) {
			mole.setState(Mole.STATE_ATTACK);
			
			for(int i = 0 ; i < moles.length ; i++) {
				if (moles[i] == mole) {
					if (moleTimers[i] != null) moleTimers[i].stop();
					moleTimers[i] = new MoleTimer(mole, Mole.STATE_NONE, 500);
					break;
				}
			}
		}
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
}

class MoleTimer implements ActionListener {
	private Mole mole;
	private int state;
	private javax.swing.Timer timer;

	public MoleTimer(Mole mole, int state, int time) {
		this.mole = mole;
		this.state = state;
		this.timer = new javax.swing.Timer(time, this);
		this.timer.start();
	}
	public void stop() {
		timer.stop();
	}

	public void actionPerformed(ActionEvent e) {
		mole.setState(state);
		timer.stop();
	}
}

class Mole extends JComponent {
	public static final int STATE_NONE = 0;
	public static final int STATE_MOLE = 1;
	public static final int STATE_ATTACK = 2;
	
	private Image none, mole, attack;
	private int state = STATE_NONE;

	public void setNoneImage(Image image) {
		this.none = image;
		if (state == STATE_NONE) repaint();
	}
	public Image getNoneImage() { return none; }

	public void setMoleImage(Image image) {
		this.mole = image;
		if (state == STATE_MOLE) repaint();
	}
	public Image getMoleImage() { return mole; }

	public void setAttackImage(Image image) {
		this.attack = image;
		if (state == STATE_ATTACK) repaint();
	}
	public Image getAttackImage() { return attack; }

	public void setState(int state) {
		this.state = state;
		repaint();
	}
	public int getState() { return state; }

	public void paintComponent(Graphics g) {
		Image drawImage = null;

		if (getState() == STATE_NONE) drawImage = none;
		else if (getState() == STATE_MOLE) drawImage = mole;
		else if (getState() == STATE_ATTACK) drawImage = attack;

		if (drawImage != null)
			g.drawImage(drawImage, 0 , 0 , getWidth(), getHeight(), this); 
	}
}