import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Typing extends JFrame implements KeyListener {
	public static void main(String[] args) {
		JFrame frame = new Typing("^CsO");
		frame.setBounds(0 , 0 , 640 , 480);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	private JLabel label;
	private Random random;
	private String[] words = {
		"have", "do", "be", "make", "can", "will", "think", "see", "want",
		"get", "break", "sing", "swim", "love", "what", "who", "when", "where",
		"why", "how", "go", "come", "know", "word"
	};
	public Typing(String title) {
		super(title);

		random = new Random(System.currentTimeMillis());
		label = new JLabel(words[random.nextInt(words.length)]);
		label.setFont(new Font(null, Font.PLAIN, 30));
		label.setHorizontalAlignment(JLabel.CENTER);
		label.setVerticalAlignment(JLabel.CENTER);

		getContentPane().add(label);
		addKeyListener(this);
	}

	public void keyPressed(KeyEvent e) {}
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {
		String text = label.getText();
		if (text.charAt(0) == e.getKeyChar()) {
			if (text.length() > 1) {
				label.setText(text.substring(1));
			}
			else label.setText(words[random.nextInt(words.length)]);
		}
		repaint();
	}
}