import java.util.*;
import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

class Test extends JComponent {
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.getContentPane().add(new Test());
		frame.setBounds(0 , 0 , 400 , 300);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	Image image;
	ImageProducer producer;
	public Test() {
		ConsoleConsumer consumer = new ConsoleConsumer();
		image = getToolkit().createImage("test.jpg");
		image.getSource().startProduction(consumer);
	}
	public void paintComponent(Graphics g) {
		g.drawImage(image, 0 , 0 , this);
	}
}

class ConsoleConsumer implements ImageConsumer {
	public void imageComplete(int status) {
		System.out.println("imageComplete:" + status);
	}
	public void setColorModel(ColorModel model) {
		System.out.println("setColorModel:" + model);
	}
	public void setDimensions(int width, int height) {
		System.out.println("setDimensions:Width=" + width + ",Height=" + height);
	}
	public void setHints(int hintflags) {
		System.out.println("setHints:" + hintflags);
	}
	public void setPixels(int x, int y, int w, int h, ColorModel model, byte[] pixels, int off, int scansize) {
		System.out.println("setPixels:X=" + x + ",Y=" + y + ",W=" + w + ",H=" + h);
		System.out.println("\tColorModel=" + model);
		System.out.println("\tPixelsLength=" + pixels.length);
		System.out.println("\tOffset=" + off + ",ScanSize=" + scansize);
	}
	public void setPixels(int x, int y, int w, int h, ColorModel model, int[] pixels, int off, int scansize) {
		System.out.println("setPixels:X=" + x + ",Y=" + y + ",W=" + w + ",H=" + h);
		System.out.println("\tColorModel=" + model);
		System.out.println("\tPixelsLength=" + pixels.length);
		System.out.println("\tOffset=" + off + ",ScanSize=" + scansize);
	}
	public void setProperties(Hashtable<?,?> props) {
		System.out.println("setProperties:" + props);
	}
}