import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

class Test extends JComponent {
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.getContentPane().add(new Test());
		frame.setBounds(0 , 0 , 400 , 300);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	Image image;
	ImageProducer producer;
	public Test() {
		producer = new MyImage(400 , 300);
		image = createImage(producer);
	}
	public void paintComponent(Graphics g) {
		g.drawImage(image, 0 , 0 , this);
	}
}

class MyImage implements ImageProducer {
	Dimension dim;
	public MyImage(int w, int h) {
		dim = new Dimension(w, h);
	}

	public void addConsumer(ImageConsumer ic) {
		System.out.println("addConsumer:" + ic);
	}
	public boolean isConsumer(ImageConsumer ic) {
		System.out.println("isConsumer:" + ic);
		return false;
	}
	public void removeConsumer(ImageConsumer ic) {
		System.out.println("removeConsumer:" + ic);
	}
	public void startProduction(ImageConsumer ic) {
		System.out.println("startProduction:" + ic);
		requestTopDownLeftRightResend(ic);
	}
	public void requestTopDownLeftRightResend(ImageConsumer ic) {
		System.out.println("requestTopDownLeftRightResend:" + ic);

		int[] pixels = new int[dim.width * dim.height];
		for(int h = 0, i = 0 ; h < dim.height ; h++) {
			int r = (h * 255) / dim.height;
			for(int w = 0 ; w < dim.width ; w++) {
				pixels[i++] = ( 0xFF << 24 ) | r << 16 ;
			}
		}
		ic.setDimensions(dim.width, dim.height);
		ic.setHints(ImageConsumer.TOPDOWNLEFTRIGHT);
		ColorModel model = new DirectColorModel(32, 0xFF, 0xFF00, 0xFF0000);
		ic.setPixels(0 , 0 , dim.width, dim.height , ColorModel.getRGBdefault(), pixels, 0 , dim.width);
		ic.imageComplete(ImageConsumer.STATICIMAGEDONE);
	}
}