import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

interface Counter {
	void increment();
	void decrement();
}

class Test extends JComponent implements Counter, MouseListener {
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.getContentPane().add(new Test());
		frame.setBounds(0 , 0 , 400 , 300);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	int count;
	CountThread thread;
	public Test() {
		addMouseListener(this);
		thread = new CountThread(this);
		thread.start();
	}

	public void increment() {
		count++;
		repaint();
	}
	public void decrement() {
		count--;
		repaint();
	}

	public void paintComponent(Graphics g) {
		if (count < 0) g.setColor(new Color(0xFF, 0, 0));
		else g.setColor(new Color(0, 0, 0xFF));
		g.drawString("COUNT=" + count, 0 , 20);
	}

	public void mouseClicked(MouseEvent e) {
		thread.setIncrement(!thread.isIncrement());
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
}

class CountThread extends Thread {
	private Counter c;
	private boolean increment;

	public CountThread(Counter c) {
		this.c = c;
		increment = true;
	}

	public boolean isIncrement() {
		return increment;
	}
	public void setIncrement(boolean increment) {
		this.increment = increment;
	}

	public void run() {
		while(true) {
			if (increment) c.increment();
			else c.decrement();
		}
	}
}