import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;

class Test extends JComponent implements MouseListener {
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.getContentPane().add(new Test());
		frame.setBounds(0 , 0 , 400 , 300);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	BufferedImage image;
	public Test() {
		addMouseListener(this);
		image = new BufferedImage(400, 300, BufferedImage.TYPE_INT_RGB);
		Graphics g = image.getGraphics();
		g.setColor(new Color(0xFF, 0xFF, 0xFF));
		g.fillRect(0, 0, 400, 300);
	}

	public void paintComponent(Graphics g) {
		g.drawImage(image, 0, 0, this);
	}

	public void mouseClicked(MouseEvent e) {
		Thread thread = new DrawThread(this, image, e.getX(), e.getY());
		thread.start();
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
}

class DrawThread extends Thread {
	Component com;
	BufferedImage image;
	int x, y;

	public DrawThread(Component com, BufferedImage image, int x, int y) {
		this.com = com;
		this.image = image;
		this.x = x;
		this.y = y;
	}

	public void run() {
		System.out.println("Start:Name=" + getName() + ",ID=" + getId());
		Graphics g = image.getGraphics();
		g.setColor(new Color(0, 0, 0));

		while(y < image.getHeight()) {
			g.fillOval(x - 5 , y - 5 , 10 , 10);
			com.repaint();
			y++;
			try { sleep(100); }
			catch(java.lang.InterruptedException err) {}
		}

		System.out.println("End:Name=" + getName() + ",ID=" + getId());
	}
}