import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;

interface TestGraphics {
	void drawPoint(int x, int y);
}

class Test extends JComponent implements TestGraphics, MouseListener {
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.getContentPane().add(new Test());
		frame.setBounds(0 , 0 , 400 , 300);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	BufferedImage image;
	public Test() {
		addMouseListener(this);
		image = new BufferedImage(400, 300, BufferedImage.TYPE_INT_RGB);
		Graphics g = image.getGraphics();
		g.setColor(new Color(0xFF, 0xFF, 0xFF));
		g.fillRect(0, 0, 400, 300);
	}

	public void paintComponent(Graphics g) {
		g.drawImage(image, 0, 0, this);
	}

	public void drawPoint(int x, int y) {
		Graphics g = image.getGraphics();
		g.setColor(new Color(0, 0, 0));
		g.fillOval(x - 5 , y - 5 , 10 , 10);
		repaint();
	}

	public void mouseClicked(MouseEvent e) {
		Thread thread = new DrawThread(
			this, e.getX(), e.getY(), image.getHeight()
		);
		thread.start();
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
}

class DrawThread extends Thread {
	TestGraphics g;
	int x, y, max;

	public DrawThread(TestGraphics g, int x, int y, int max) {
		this.g = g;
		this.x = x;
		this.y = y;
		this.max = max;
	}

	public void run() {
		while(y < max) {
			synchronized(g) {
				g.drawPoint(x, y);
				try { Thread.currentThread().sleep(100); }
				catch(java.lang.InterruptedException err) {}
			}
			y += 3;
		}
	}
}