import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import javax.swing.*;

class Test extends JComponent implements Runnable {
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.getContentPane().add(new Test());
		frame.setBounds(0 , 0 , 640 , 480);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	private static final int FPS = 60;
	private Thread thread;
	private BufferedImage offScreen;
	public Test() {
		offScreen = new BufferedImage(640, 480, BufferedImage.TYPE_INT_RGB);
		thread = new Thread(this);
		thread.start();
	}

	public void run() {
		int width = offScreen.getWidth(this);
		int height = offScreen.getHeight(this);
		BufferedImage buffer = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
		int frames = 0;
		String strfps = "v";
		long beforeTime = System.currentTimeMillis();
		Image image = getToolkit().createImage("test.jpg");
		int angdeg = 0;

		while(true) {
			long nowTime = System.currentTimeMillis();
			long progress = nowTime - beforeTime;
			long idealTime = (long)(frames * (1000.0 / FPS));
			
			AffineTransform xform = AffineTransform.getRotateInstance(
				Math.toRadians(angdeg) , 300 , 200
			);
			angdeg++;
			if (angdeg == 360) angdeg = 0;

			Graphics2D g = buffer.createGraphics();
			g.setColor(getBackground());
			g.fillRect(0, 0, width, height);
			g.setColor(getForeground());
			g.drawImage(image, xform, this);
			g.drawString(strfps, 10, 20);
			g.finalize();

			g = offScreen.createGraphics();
			g.drawImage(buffer, 0, 0, this);
			g.finalize();

			try {
				if (idealTime > progress)
					Thread.sleep(idealTime - progress);
				repaint();
			}
			catch(Exception err) { System.out.println(err); }

			if (progress >= 1000) {	//1bo
				strfps = "FPS=" + frames;
				beforeTime = nowTime;
				frames = 0;
			}
			frames++;
		}
	}

	public void paintComponent(Graphics g) {
		g.drawImage(offScreen, 0, 0, this);
	}
}