import java.util.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;

public class Fall {
	public static void main(String[] args) {
		FallPane fallPane = new FallPane();

		JFrame frame = new JFrame("ĂʂE");
		frame.setSize(400, 600);
		frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
		frame.getContentPane().add(fallPane);

		frame.setVisible(true);
	}
}

//Ă{[\ۃNX
abstract class AbstractFallBall {
	private Point location;
	private Dimension size;
	private double verticalAccel;
	private double horizontalAccel;

	public AbstractFallBall() {
		location = new Point(0, 0);
		size = new Dimension(0, 0);
	}

	//{[XW
	public int getX() { return location.x; }	
	//{[YW
	public int getY() { return location.y; }

	//{[̕
	public int getWidth() { return size.width; }
	//{[̍
	public int getHeight() { return size.height; }

	//{[̈ʒuƃTCY
	public void setBounds(Rectangle value) {
		location = value.getLocation();
		size = value.getSize();
	}
	public Rectangle getBounds() { return new Rectangle(location, size); }

	//{[̍W
	public void setLocation(Point value) { location = value; }
	public Point getLocation() { return new Point(location); }

	//{[TCY
	public void setSize(Dimension value) { size = value; }
	public Dimension getSize() { return new Dimension(size); }

	//̉Zl
	public void setVerticalAccel(double value) { verticalAccel = value; }
	public double getVerticalAccel() { return verticalAccel;}

	//̉Zl
	public void setHorizontalAccel(double value) { horizontalAccel = value; }
	public double getHorizontalAccel() { return horizontalAccel;}

	//{[`悷
	public abstract void paintBall(Component target, Graphics g);
}

//{[̊̎
class DefaultFallBall extends AbstractFallBall {
	private Color color;

	public DefaultFallBall() {
		color = Color.BLACK;
	}

	public void setColor(Color value) { color = value; }
	public Color getColor() { return color; }

	public void paintBall(Component target, Graphics g) {
		Rectangle rect = getBounds();
		g.setColor(color);
		g.fillOval(rect.x, rect.y, rect.width, rect.height);
	}
}

class BallController implements Runnable {
	private FallPane fallPane;
	private AbstractFallBall fallBall;
	private Thread thread;
	private int sleepTime;
	private boolean stoped;

	public BallController(FallPane fallPane, AbstractFallBall fallBall) {
		this.fallPane = fallPane;
		this.fallBall = fallBall;
		sleepTime = 10;
	}

	//Xbh̑x肷lB
	public void setSleepTime(int value) { sleepTime = value; }
	public int getSleepTime() { return sleepTime; }

	//XbhJn
	public void start() {
		if (thread != null && thread.isAlive()) {
			throw new IllegalStateException();
		}
		stoped = false;
		thread = new Thread(this);
		thread.start();
	}
	//XbhI
	public void stop() {
		stoped = true;
	}

	public void run() {
		while(!stoped) {
			try {
				Thread.sleep(getSleepTime());
			}
			catch(Exception e) {
			}

			//{[ړ
			Rectangle ball = fallBall.getBounds();
			ball.x += fallBall.getHorizontalAccel();
			ball.y += fallBall.getVerticalAccel();

			//
			fallBall.setVerticalAccel(fallBall.getVerticalAccel() + 0.1);

			//o[ƃ{[̒ʒuZo
			Rectangle bar = fallPane.getBarBounds();
			int barCenter = bar.x + bar.width / 2;
			int ballCenter = ball.x + ball.width / 2;

			//蔻
			if (bar.intersects(fallBall.getBounds())) {
				ball.y = bar.y - ball.height;
				fallBall.setVerticalAccel(-(fallBall.getVerticalAccel() * 0.8));


				fallBall.setHorizontalAccel(-((barCenter - ballCenter) * 0.1));
			}
			else if (ball.y > fallPane.getHeight()) break;	//{[

			//{[ʂ̒[ɏՓ˂
			if (ball.x < 0 || (ball.x + ball.width) > fallPane.getWidth()) {
				fallBall.setHorizontalAccel(-fallBall.getHorizontalAccel());
			}

			fallBall.setBounds(ball);
			fallPane.repaint();
		}
		fallPane.removeFallBall(fallBall);
	}
}

//EBhEɕ\Q[
class FallPane extends JComponent implements MouseMotionListener, MouseListener, ComponentListener {
	private Vector<AbstractFallBall> balls;
	private Rectangle bar;
	private Random random;

	public FallPane() {
		bar = new Rectangle(0, 0, 100, 20);
		balls = new Vector<AbstractFallBall>();
		random = new Random();

		addComponentListener(this);
		addMouseListener(this);
		addMouseMotionListener(this);
	}

	//w肳ꂽ{[ǉ
	public void addFallBall(AbstractFallBall fallBall) {
		balls.add(fallBall);
		BallController ballctrl = new BallController(this, fallBall);
		ballctrl.start();
	}
	//w肵CfbNX̃{[Ԃ
	public AbstractFallBall getFallBall(int index) {
		return balls.get(index);
	}
	//w肳ꂽ{[폜
	public void removeFallBall(AbstractFallBall fallBall) {
		balls.remove(fallBall);
	}
	//w肳ꂽCfbNX̃{[폜
	public void removeFallBall(int index) {
		balls.remove(index);
	}

	//[U[삷o[̍WƃTCY
	public Rectangle getBarBounds() {
		return new Rectangle(bar);
	}

	public void componentHidden(ComponentEvent e) {}
	public void componentMoved(ComponentEvent e) {}
	public void componentResized(ComponentEvent e) {
		bar.y = getHeight() - bar.height * 2;
		repaint();
	}
	public void componentShown(ComponentEvent e) {}

	//NbNƃ{[𑝂₷
	public void mouseClicked(MouseEvent e) {
		DefaultFallBall ball = new DefaultFallBall();
		Dimension dim = new Dimension(20, 20);
		Point pt = new Point(random.nextInt(getWidth() - dim.width), dim.height);

		ball.setColor(new Color(random.nextInt(255), random.nextInt(255), random.nextInt(255)));
		ball.setLocation(pt);
		ball.setSize(dim);
		ball.setVerticalAccel(1.0);
		ball.setHorizontalAccel(1.0);
		addFallBall(ball);
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}

	public void mouseDragged(MouseEvent e) {}
	public void mouseMoved(MouseEvent e) {
		int x = e.getX() - (bar.width / 2);
		if (x < 0) bar.x = 0;
		else if(x + bar.width > getWidth()) bar.x = getWidth() - bar.width;
		else bar.x = x;
		repaint();
	}
	
	public void paintComponent(Graphics g) {
		g.fillRect(bar.x, bar.y, bar.width, bar.height);
		for(int i = 0 ; i < balls.size() ; i++) {
			AbstractFallBall ball = balls.get(i);
			ball.paintBall(this, g);
		}
	}
}