import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class ChatClient extends JComponent implements KeyListener, Runnable {
	public static void main(String[] args) throws Exception {
		if (args.length == 0) return;
		String host = args[0];

		JFrame frame = new JFrame();
		frame.getContentPane().add(new ChatClient(host, 2345));
		frame.setBounds(0 , 0 , 400 , 300);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	Socket socket;
	JTextArea textArea;
	JTextField textField;
	public ChatClient(String host, int port) throws IOException {
		socket = new Socket(host, port);
		setLayout(new BorderLayout());

		textArea = new JTextArea();
		textArea.setEditable(false);
		textField = new JTextField();

		textField.addKeyListener(this);

		add(textArea, BorderLayout.CENTER);
		add(textField, BorderLayout. SOUTH);

		Thread thread = new Thread(this);
		thread.start();
	}
	public void run() {
		try {
			InputStream stream = socket.getInputStream();
			BufferedReader reader = new BufferedReader(
				new InputStreamReader(stream)
			);
			while(!socket.isClosed()) {
				String msg = reader.readLine();
				if (msg == null) break;
				textArea.setText(textArea.getText() + "\n>" + msg);
			}
		}
		catch(Exception err) { System.out.println(err); }
	}

	public void keyPressed(KeyEvent e) {}
	public void keyReleased(KeyEvent e) {
		if (e.getKeyCode() == KeyEvent.VK_ENTER) {
			if (socket.isClosed()) return;
			String msg = textField.getText();
			try {
				OutputStream stream = socket.getOutputStream();
				PrintWriter writer = new PrintWriter(stream);
				writer.println(msg);
				writer.flush();

				textField.setText("");
			}
			catch(Exception err) { System.out.println(err); }
		}
	}
	public void keyTyped(KeyEvent e) {}
}